/*
  Copyright (c) 2014 Arduino.  All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdlib.h>
#ifdef GRROSE
#ifndef USING_AZURE_RTOS
#include "FreeRTOS.h"
#else
#endif // AZURE_RTOS
#endif

void *operator new(size_t size) {
#ifndef GRROSE
  return malloc(size);
#else
#ifndef USING_AZURE_RTOS
  return pvPortMalloc(size);
#else
  return malloc(size);
#endif // AZURE_RTOS
#endif
}

void *operator new[](size_t size) {
#ifndef GRROSE
  return malloc(size);
#else
#ifndef USING_AZURE_RTOS
  return pvPortMalloc(size);
#else
  return malloc(size);
#endif // AZURE_RTOS
#endif
}

void operator delete(void * ptr) {
#ifndef GRROSE
  free(ptr);
#else
#ifndef USING_AZURE_RTOS
  vPortFree(ptr);
#else
  free(ptr);
#endif // AZURE_RTOS
#endif
}

void operator delete[](void * ptr) {
#ifndef GRROSE
  free(ptr);
#else
#ifndef USING_AZURE_RTOS
  vPortFree(ptr);
#else
  free(ptr);
#endif // AZURE_RTOS
#endif
}

