/**************************************************************************/
/*                                                                        */
/*       Copyright (c) Microsoft Corporation. All rights reserved.        */
/*                                                                        */
/*       This software is licensed under the Microsoft Software License   */
/*       Terms for Microsoft Azure RTOS. Full text of the license can be  */
/*       found in the LICENSE file at https://aka.ms/AzureRTOS_EULA       */
/*       and in the root directory of this software.                      */
/*                                                                        */
/**************************************************************************/
#include "nx_api.h"

/* Include the platform IP driver. */
VOID platform_setup(void);

#ifdef GRROSE
#include <Arduino.h>
#define SKETCH_STACK_SIZE 4096
#define SKETCH_THREAD_PRIORITY 4
static ULONG sketch_thread_stack[SKETCH_STACK_SIZE / sizeof(ULONG)];
void sketch_thread_entry(ULONG parameter);
static TX_THREAD        sketch_thread;
#endif
/* Define main entry point.  */
int main(void)
{
	init();
    /* Enter the ThreadX kernel.  */
    tx_kernel_enter();
}

/* Define what the initial system looks like.  */
void    tx_application_define(void *first_unused_memory)
{
	UINT  status;

#ifdef GRROSE
    /* Create sketch thread. */
	status = tx_thread_create(&sketch_thread, "Sketch Thread",
    		                  sketch_thread_entry, 0,
							  sketch_thread_stack, SKETCH_STACK_SIZE,
                              SKETCH_THREAD_PRIORITY, SKETCH_THREAD_PRIORITY,
                              TX_NO_TIME_SLICE, TX_AUTO_START);

    if (status)
    {
        printf("sketch thread creation fail: %u\r\n", status);
        return;
    }
#endif

}

void sketch_thread_entry(ULONG parameter)
{
    setup();

    for (;;) {
        loop();
    }
}
